/*
 * main.c
 *
 *  Created on: 2012.11.12.
 *      Author: MaSTeRFoXX
 */

#include <stm32f0xx_conf.h>

volatile uint32_t ledcounter;
volatile uint8_t pwm_duty;

void delay(void)
{
	volatile uint32_t i=0;

	for(i=0; i<100000; i++)
	{
	}
}


void hwinit(void)
{
	GPIO_InitTypeDef GPIO_initstruct;

	RCC_AHBPeriphClockCmd(RCC_AHBENR_GPIOCEN,ENABLE);

	GPIO_initstruct.GPIO_Pin=GPIO_Pin_8;
	GPIO_initstruct.GPIO_PuPd=GPIO_PuPd_NOPULL;
	GPIO_initstruct.GPIO_OType=GPIO_OType_PP;
	GPIO_initstruct.GPIO_Mode=GPIO_Mode_OUT;
	GPIO_initstruct.GPIO_Speed=GPIO_Speed_50MHz;

	GPIO_Init(GPIOC,&GPIO_initstruct);

}

void PWM_init(void)
{
	GPIO_InitTypeDef GPIO_initstruct;
	TIM_TimeBaseInitTypeDef  TIM_timebase;
	TIM_OCInitTypeDef  TIM_OCInitStructure;

	//rajel ads a timernak ->adatlap hogy melyik buszon van!!!
	RCC_APB1PeriphClockCmd(RCC_APB1ENR_TIM3EN,ENABLE);

	//bekonfigurlni hogy a PC9 lb alternatv funkciban mkdjn
	GPIO_initstruct.GPIO_Pin=GPIO_Pin_9;
	GPIO_initstruct.GPIO_PuPd=GPIO_PuPd_NOPULL; //fel/lehzs
	GPIO_initstruct.GPIO_OType=GPIO_OType_PP; //puspull
	GPIO_initstruct.GPIO_Mode=GPIO_Mode_AF; //alternatv funkci -> CSAK 1db van
	GPIO_initstruct.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_Init(GPIOC,&GPIO_initstruct);

	TIM_timebase.TIM_Prescaler=4800;   //48MHz/4800/periodus=100Hz
	TIM_timebase.TIM_Period=100; //A peridus=100
	TIM_timebase.TIM_CounterMode=TIM_CounterMode_Up; //felfele szmol
	TIM_timebase.TIM_ClockDivision=0; //ez nincs a TIM3ban
	TIM_timebase.TIM_RepetitionCounter=0; //ez nincs a TIM3ban

	TIM_TimeBaseInit(TIM3,&TIM_timebase); //Idalap bekonfolsa

	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM2;
	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_Low;
	TIM_OCInitStructure.TIM_OCIdleState = TIM_OCIdleState_Set;

	TIM_OCInitStructure.TIM_Pulse = 50; //kitltsi tnyez

	TIM_OC4Init(TIM3,&TIM_OCInitStructure);

	TIM_Cmd(TIM3,ENABLE); //timer be
	TIM_CtrlPWMOutputs(TIM3,ENABLE); //kimenetek be
}

void Timer_IT_init(void)
{
	 NVIC_InitTypeDef  NVIC_InitStructure;

	TIM_ClearFlag(TIM3, TIM_FLAG_Update); //biztonsg kedvrt

	//TIM3 IT konfig
	NVIC_InitStructure.NVIC_IRQChannel = TIM3_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPriority=0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);

	//Timer IT be
	TIM_ITConfig(TIM3, TIM_IT_Update,ENABLE); //amikor elri a szmll a peridus rtkt

}

int main(void)
{
	hwinit();
	PWM_init();
	Timer_IT_init();

	ledcounter=0;
	while(1)
	{

	}

}

void TIM3_IRQHandler(void)
{
	ledcounter++;
	if(ledcounter==50)
	{
		ledcounter=0; //2Hz-es villogs
		if(GPIOC->ODR&GPIO_Pin_8) //Ha 1-es van a kimen adatregiszterben
		{
			GPIO_ResetBits(GPIOC,GPIO_Pin_8); //LED ki
		}
		else
		{
			GPIO_SetBits(GPIOC,GPIO_Pin_8); //LED be
		}
	}

	//kitltsi tnyez lltsa
	pwm_duty++;
	if(pwm_duty>100) pwm_duty=0;
	TIM3->CCR4=pwm_duty;

	//flag trlse
	TIM_ClearFlag(TIM3, TIM_FLAG_Update);
}


void HardFault_Handler(void)
{
  while (1)
  {
  }
}



